#include <asm/types.h>
#include <stdlib.h>
#include "packet80211b.h"
#include "ap_packet.h"


extern ap_packet_elem *ap_packet_list;

void
add_ap_packet (packet80211b p)
{
  ap_packet_elem *new;
  new = (ap_packet_elem *) malloc (sizeof (ap_packet_elem));
  memcpy (new->data.ap_mac, &p.packetdata[16], ETH_HW_ADDR_LEN);
  memcpy (new->data.dst_mac, &p.packetdata[4], ETH_HW_ADDR_LEN);
  new->data.type = p.packetdata[0];
  new->data.packet_time = p.packet_time;
  new->next = ap_packet_list;
  ap_packet_list = new;
}


void
flush_ap_packet (struct timeval date)
{

  ap_packet_elem *current;
  ap_packet_elem *precedent;
  int i = 0;

  while ((ap_packet_list != NULL)
	 && ((ap_packet_list->data.packet_time.tv_sec < date.tv_sec)
	     || ((ap_packet_list->data.packet_time.tv_sec == date.tv_sec)
		 && (ap_packet_list->data.packet_time.tv_usec <
		     date.tv_usec))))
    {
      current = ap_packet_list;
      ap_packet_list = current->next;
      free (current);
    }


  current = ap_packet_list;
  while (current != NULL)
    {
      precedent = current;
      current = current->next;
      if ((current != NULL)
	  && ((current->data.packet_time.tv_sec < date.tv_sec)
	      || ((current->data.packet_time.tv_sec == date.tv_sec)
		  && (current->data.packet_time.tv_usec < date.tv_usec))))
	{
	  precedent->next = current->next;
	  free (current);
	  current = precedent;
	}
    }
  /*
     current=ap_packet_list;
     while (current != NULL) {
     i++;
     current=current->next;
     }
   */

}

ap_packet_elem *
find_ap_packet_elem (ap_packet * packet)
{
  /* ap_mac, dst_mac & message_type are our "primary key" in the list */
  ap_packet_elem *current = ap_packet_list;

  while ((current != NULL) &&
	 ((memcmp (packet->ap_mac, current->data.ap_mac, ETH_HW_ADDR_LEN) !=
	   0)
	  || (memcmp (packet->dst_mac, current->data.dst_mac, ETH_HW_ADDR_LEN)
	      != 0) || (packet->type != current->data.type)))
    current = current->next;

  return current;
}
