#include <asm/types.h>
#include <stdlib.h>
#include "packet80211b.h"
#include "beacon_interval.h"


extern beacon_interval_elem *beacon_interval_list;

void
add_beacon_interval (packet80211b p)
{
  /* p is beacon frame == true */
  beacon_interval_elem *new =
    (beacon_interval_elem *) malloc (sizeof (beacon_interval_elem));
  new->data.beacon_interval =
    (p.packetdata[32] + p.packetdata[33] * 16) * 1024;
  memcpy (new->data.ap_mac, &p.packetdata[16], ETH_HW_ADDR_LEN);
  new->next = beacon_interval_list;
  beacon_interval_list = new;
}

beacon_interval_elem *
find_beacon_interval (packet80211b p)
{
  beacon_interval_elem *current = beacon_interval_list;
  while ((current != NULL) &&
	 (memcmp (&p.packetdata[16], current->data.ap_mac, ETH_HW_ADDR_LEN) !=
	  0))
    current = current->next;
  return current;
}

int
beacon_interval_val (packet80211b p)
{
  beacon_interval_elem *current = beacon_interval_list;
  while ((current != NULL)
	 && (memcmp (&p.packetdata[16], current->data.ap_mac, ETH_HW_ADDR_LEN)
	     != 0))
    current = current->next;
  if (current == NULL)
    return (-1);
  else
    return current->data.beacon_interval;
}
