#include <asm/types.h>
#include <stdlib.h>
#include "packet80211b.h"
#include "sequence_number.h"

#define MAX_DELTA_SEQNUM 50


extern sequence_number_elem *sequence_number_list;


int
curious_seq_num (packet80211b p)
{
  int new_seq_num, last_seq_num;
  new_seq_num = p.packetdata[23] * 16 + p.packetdata[22] / 16;
  last_seq_num = last_sequence_num (&p.packetdata[16]);

  if ((last_seq_num != -1)
      && ((abs (new_seq_num - last_seq_num) > MAX_DELTA_SEQNUM)
	  && (abs (new_seq_num - last_seq_num) < 4096 - MAX_DELTA_NUMSEQ)))
    {
      /* sequence number seems bad... */
      return 1;
    }

  if ((last_seq_num != 1)
      && ((abs (new_seq_num - last_seq_num) < MAX_DELTA_SEQNUM)
	  || (abs (new_seq_num - last_seq_num) > 4096 - MAX_DELTA_NUMSEQ)))
    {
      /* sequence number seems ok... */
      actualize_sequence_num (&p.packetdata[16], new_seq_num);
    }

  if (last_seq_num == -1)
    add_sequence_number (p);

  return 0;
}
