#include <asm/types.h>
#include <stdlib.h>
#include "packet80211b.h"


extern packet80211b_elem *packet_list;

void
add_packet80211b (packet80211b p)
{
  packet80211b_elem *new;
  new = (packet80211b_elem *) malloc (sizeof (packet80211b_elem));
  new->data = p;
  new->next = packet_list;
  packet_list = new;
}


void
flush_packet80211b (struct timeval date)
{

  packet80211b_elem *current;
  packet80211b_elem *precedent;
  int i = 0;

  current = packet_list;
  while (current != NULL)
    {
      i++;
      current = current->next;
    }



  while ((packet_list != NULL)
	 && ((packet_list->data.packet_time.tv_sec < date.tv_sec)
	     || ((packet_list->data.packet_time.tv_sec == date.tv_sec)
		 && (packet_list->data.packet_time.tv_usec < date.tv_usec))))
    {
      current = packet_list;
      packet_list = current->next;
      free (current);
    }


  current = packet_list;
  while (current != NULL)
    {
      precedent = current;
      current = current->next;
      if ((current != NULL)
	  && ((current->data.packet_time.tv_sec < date.tv_sec)
	      || ((current->data.packet_time.tv_sec == date.tv_sec)
		  && (current->data.packet_time.tv_usec < date.tv_usec))))
	{
	  precedent->next = current->next;
	  free (current);
	  current = precedent;
	}
    }
  current = packet_list;
  while (current != NULL)
    {
      i++;
      current = current->next;
    }

}

int
is_data (packet80211b p)
{
  if (p.packetdata[0] == 0x08)
    return 1;
  return 0;
}

int
is_beacon (packet80211b p)
{
  if (p.packetdata[0] == 0x80)
    return 1;
  return 0;
}

int
is_ap_mgt (packet80211b p)
{

  if ((p.packetdata[0] == 0x10) || (p.packetdata[0] == 0x30)
      || (p.packetdata[0] == 0x50) || (p.packetdata[0] == 0xa0)
      || (p.packetdata[0] == 0xc0) || ((p.packetdata[0] == 0xb0)
				       &&
				       (memcmp
					(&p.packetdata[10], &p.packetdata[16],
					 ETH_HW_ADDR_LEN) == 0)))
    return 1;
  return 0;
}

int
is_card_mgt (packet80211b p)
{
  if ((p.packetdata[0] == 0x00) || (p.packetdata[0] == 0x20)
      || (p.packetdata[0] == 0x40) || ((p.packetdata[0] == 0xb0)
				       &&
				       (memcmp
					(&p.packetdata[4], &p.packetdata[16],
					 ETH_HW_ADDR_LEN) == 0)))
    return 1;
  return 0;
}


int
is_negative_auth (packet80211b p)
{

  /* we suppose it's an AP packet */
  __u8 shared_key[] = { 0x01, 0x00 };
  __u8 auth_seq[] = { 0x03, 0x00 };
  __u8 result[] = { 0x00, 0x00 };

  if ((p.packetdata[0] == 0xb0) &&
      (memcmp (&p.packetdata[24], shared_key, 2) == 0) &&
      (memcmp (&p.packetdata[26], auth_seq, 2) == 0) &&
      (memcmp (&p.packetdata[28], result, 2) != 0))
    {
      return 1;
    }
  return 0;
}
