#include <asm/types.h>
#include <stdlib.h>
#include "packet80211b.h"
#include "sequence_number.h"


extern sequence_number_elem *sequence_number_list;

void
add_sequence_number (packet80211b p)
{
  sequence_number_elem *current = sequence_number_list;
  while ((current != NULL)
	 && (memcmp (&p.packetdata[16], current->data.ap_mac, ETH_HW_ADDR_LEN)
	     != 0))
    current = current->next;
  if (current == NULL)
    {
      sequence_number_elem *new =
	(sequence_number_elem *) malloc (sizeof (sequence_number_elem));
      new->data.sequence_number =
	p.packetdata[23] * 16 + p.packetdata[22] / 16;
      memcpy (new->data.ap_mac, &p.packetdata[16], ETH_HW_ADDR_LEN);
      new->next = sequence_number_list;
      sequence_number_list = new;
    }
  else
    current->data.sequence_number =
      p.packetdata[23] * 16 + p.packetdata[22] / 16;
}

sequence_number_elem *
find_sequence_number (__u8 * ap_mac)
{
  sequence_number_elem *current = sequence_number_list;
  while ((current != NULL)
	 && (memcmp (ap_mac, current->data.ap_mac, ETH_HW_ADDR_LEN) != 0))
    current = current->next;
  return current;
}

int
last_sequence_num (__u8 * ap_mac)
{
  sequence_number_elem *current = sequence_number_list;
  while ((current != NULL)
	 && (memcmp (ap_mac, current->data.ap_mac, ETH_HW_ADDR_LEN) != 0))
    current = current->next;

  if (current == NULL)
    return (-1);
  else
    return current->data.sequence_number;
}

void
actualize_sequence_num (__u8 * ap_mac, int num_seq)
{
  sequence_number_elem *current = sequence_number_list;
  while ((current != NULL)
	 && (memcmp (ap_mac, current->data.ap_mac, ETH_HW_ADDR_LEN) != 0))
    current = current->next;
  if (current != NULL)
    current->data.sequence_number = num_seq;
}

void
reset_sequence_number ()
{
  int i = 0;
  sequence_number_elem *current = sequence_number_list;
  while (current != NULL)
    {
      i++;
      current->data.sequence_number = -1;
      //printf("\n AP %s seq num",human_format_hw_addr(current->data.ap_mac));
      current = current->next;
    }
  //printf("\nsequence number : %d \n",i);
}
